第4章、Alexaカスタムスキル「鳥の鳴き声クイズ」の配布用サンプルコードです。

# Windows環境の方へ

Windowsの場合、サンプルコードをメモ帳で開くとすべての行が1行につながった状態で表示されてしまいますので、代わりにVisual Studio Codeなどを利用してください。

Visual Studio Codeは次のサイトから無料でダウンロードできます。

https://code.visualstudio.com/

# sound-quiz.js（クイズ生成ライブラリ）

`sound-quiz.js`の先頭部分の`sounds`（音一覧）を、実在するMP3ファイルのURLに置き換えてください。`https://`から始まるURLでないと動作しません。

# index.js（メインプログラム）

`index.js`の`SKILL_ID`を実際のスキルIDに書き換えてください。
スキルIDはAlexaコンソールで確認できます。

https://developer.amazon.com/alexa/console/ask

# model.json（対話モデル）

`json`ディレクトリの`model.json`は対話モデルをJSON形式でエクスポートしたものです。困ったときの参照用として利用してください。

Alexaコンソールの左サイドバー「JSONエディター」から`model.json`をアップロードして「モデルを保存」をクリックすると、インテントやスロットがすべて完成した状態になります。
エンドポイント（AWS LambdaのARN）は別途設定してください。

# コマンドラインを使ったデプロイ

コマンドラインからLambda関数をデプロイするには次の手順を行ってください。

## 1) package.jsonの編集

`package.json`の`--function-name birdsong-quiz`を実際の関数名に置き換えます。
例えばLambda関数名が`my-quiz`なら`--function-name my-quiz`とします。

## 2) IAMユーザーとアクセスキーの作成

AWSコンソールにログインし、画面右上から東京リージョンを選択します。

https://ap-northeast-1.console.aws.amazon.com/console/home?region=ap-northeast-1

AWSサービスの検索ボックスに「IAM」と入力し、IAMコンソールを開きます。

左サイドバーの「ユーザー」から「ユーザーを追加」をクリックします。
好きなユーザー名を入力し、「プログラムによるアクセス」にチェックを入れ、右下の「次のステップ: アクセス権限」をクリックします。

「既存のポリシーを直接アタッチ」を選択し、ポリシーの一覧から「AWSLambdaFullAccess」を探してチェックボックスをオンにし、右下の「次のステップ: 確認」をクリックします。

「ユーザーの作成」をクリックするとユーザーが作成されます。

表示されるアクセスキーとシークレットアクセスキーを次の手順で使います。

## 3) awsコマンドの設定

コマンドラインで`aws configure`を実行し、アクセスキーとシークレットアクセスキーを入力します。Default region nameは「ap-northeast-1」にし、Default output formatは「json」に設定します。

これで設定は完了です。
設定に問題がなければ、`aws lambda list-functions`コマンドで関数一覧が表示されます。
Lambda関数をデプロイするには`npm run deploy`を実行します。
